%bcond_with tests
%bcond_with pocl

Name:          viennacl
Version:       1.7.1
Release:       14%{?dist}
Summary:       Linear algebra and solver library using CUDA, OpenCL, and OpenMP
License:       MIT and ISC
URL:           http://viennacl.sourceforge.net/
Source0:       http://sourceforge.net/projects/%{name}/files/1.7.x/ViennaCL-%{version}.tar.gz
BuildArch:     noarch
ExclusiveArch: x86_64

Buildrequires: boost-devel
BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: ocl-icd-devel

%if %{with pocl}
BuildRequires: pocl
%endif

%description
ViennaCL provides high level C++ interfaces for linear algebra routines on CPUs
and GPUs using CUDA, OpenCL, and OpenMP. The focus is on generic implementations
of iterative solvers often used for large linear systems and simple integration
into existing projects.

%package devel
Summary:  Linear algebra and solver library using CUDA, OpenCL, and OpenMP

%description devel
ViennaCL provides high level C++ interfaces for linear algebra routines on CPUs
and GPUs using CUDA, OpenCL, and OpenMP. The focus is on generic implementations
of iterative solvers often used for large linear systems and simple integration
into existing projects.

%prep
%autosetup -n ViennaCL-%{version}

%build
%cmake \
       -Wno-dev \
       -DINSTALL_CMAKE_DIR:PATH=%{_datadir}/cmake/Modules \
       -DVIENNACL_WITH_OPENCL=ON \
       -DVIENNACL_WITH_OPENMP=ON \
       -DBUILD_TESTING=%{?with_tests:ON}%{!?with_tests:OFF}

%cmake_build

%install
%cmake_install

%if %{with tests}
%check
cd %{__cmake_builddir}
# https://sourceforge.net/p/viennacl/mailman/message/35517365/
ctest -VV --output-on-failure -E "(bisect-opencl|sparse_prod-opencl)"
%endif

%files devel
%doc README
%license LICENSE
%{_includedir}/%{name}/
%dir %{_datadir}/cmake
%dir %{_datadir}/cmake/Modules
%exclude %{_datadir}/cmake/Modules/FindOpenCL.cmake
%{_datadir}/cmake/Modules/ViennaCLConfig.cmake
%{_datadir}/cmake/Modules/ViennaCLConfigVersion.cmake

%changelog
* Sat Dec 03 2022 Tom Rix <trix@redhat.com> - 1.7.1-14
- Adopt project

* Sat Aug 01 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.1-13
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.1-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Fri Jan 31 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.1-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Sat Jul 27 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.1-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sun Feb 03 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.1-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.1-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.1-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.1-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Dec 29 2016 Ilya Gradina <ilya.gradina@gmail.com> - 1.7.1-4
- exclude in cmake modules FindOpenCL

* Thu Dec 01 2016 Ilya Gradina <ilya.gradina@gmail.com> - 1.7.1-3
- trivial changes in spec file 

* Wed Nov 30 2016 Ilya Gradina <ilya.gradina@gmail.com> - 1.7.1-2
- skipped two tests, status tests: https://sourceforge.net/p/viennacl/mailman/message/35517365/ 

* Thu Jan 21 2016 Ilya Gradina <ilya.gradina@gmail.com> - 1.7.1-1
- update to 1.7.1
- deleted example files
 
* Sat Dec 19 2015 Ilya Gradina <ilya.gradina@gmail.com> - 1.7.0-2
- add devel, doc and example files
- trivial fixes in spec

* Sun Dec 06 2015 Ilya Gradina <ilya.gradina@gmail.com> - 1.7.0-1
- Initial package
